# wxTaskBarIcon Class Reference
[Miscellaneous]

`#include <wx/taskbar.h>`

Inheritance diagram for wxTaskBarIcon:
[legend]

## Detailed Description

This class represents a taskbar icon.

A taskbar icon is an icon that appears in the 'system tray' and responds to mouse clicks, optionally with a tooltip above it to help provide information.

## X Window System Note

Under X Window System, the window manager must support either the "System Tray Protocol" (see http://freedesktop.org/wiki/Specifications/systemtray-spec) by freedesktop.org (WMs used by modern desktop environments such as GNOME >= 2, KDE >= 3 and XFCE >= 4 all do) or the older methods used in GNOME 1.2 and KDE 1 and 2.

If it doesn't, the icon will appear as a toplevel window on user's desktop. Because not all window managers have system tray, there's no guarantee that wxTaskBarIcon will work correctly under X Window System and so the applications should use it only as an optional component of their user interface. The user should be required to explicitly enable the taskbar icon on Unix, it shouldn't be on by default.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxTaskBarIconEvent& event)
Event macros for events emitted by this class:
Note that not all ports are required to send these events and so it's better to override wxTaskBarIcon::CreatePopupMenu() if all that the application does is that it shows a popup menu in reaction to mouse click.

- EVT_TASKBAR_MOVE(func):
  Process a `wxEVT_TASKBAR_MOVE` event.
- EVT_TASKBAR_LEFT_DOWN(func):
  Process a `wxEVT_TASKBAR_LEFT_DOWN` event.
- EVT_TASKBAR_LEFT_UP(func):
  Process a `wxEVT_TASKBAR_LEFT_UP` event.
- EVT_TASKBAR_RIGHT_DOWN(func):
  Process a `wxEVT_TASKBAR_RIGHT_DOWN` event.
- EVT_TASKBAR_RIGHT_UP(func):
  Process a `wxEVT_TASKBAR_RIGHT_UP` event.
- EVT_TASKBAR_LEFT_DCLICK(func):
  Process a `wxEVT_TASKBAR_LEFT_DCLICK` event.
- EVT_TASKBAR_RIGHT_DCLICK(func):
  Process a `wxEVT_TASKBAR_RIGHT_DCLICK` event.
- EVT_TASKBAR_CLICK(func):
  This is a synonym for either EVT_TASKBAR_RIGHT_DOWN or UP depending on the platform, use this event macro to catch the event which should result in the menu being displayed on the current platform.

##

Library: wxAdvanced

Category: Miscellaneous

## Public Member Functions
| wxTaskBarIcon ()
| Default constructor.
virtual | ~wxTaskBarIcon ()
| Destroys the wxTaskBarIcon object, removing the icon if not already removed.
void | Destroy ()
| This method is similar to wxWindow::Destroy and can be used to schedule the task bar icon object for the delayed destruction: it will be deleted during the next event loop iteration, which allows the task bar icon to process any pending events for it before being destroyed.
bool | IsIconInstalled () const
| Returns true if SetIcon() was called with no subsequent RemoveIcon().
bool | IsOk () const
| Returns true if the object initialized successfully.
virtual bool | PopupMenu (wxMenu *menu)
| Pops up a menu at the current mouse position.
virtual bool | RemoveIcon ()
| Removes the icon previously set with SetIcon().
virtual bool | SetIcon (const wxIcon &icon, const wxString &tooltip=wxEmptyString)
| Sets the icon, and optional tooltip text.
## Static Public Member Functions
static bool | IsAvailable ()
| Returns true if system tray is available in the desktop environment the app runs under.
## Protected Member Functions
virtual wxMenu * | CreatePopupMenu ()
| This method is called by the library when the user requests popup menu (on Windows and Unix platforms, this is when the user right-clicks the icon).

List of all members.

## Constructor & Destructor Documentation

wxTaskBarIcon::wxTaskBarIcon | ( |  | ) |

Default constructor.

virtual wxTaskBarIcon::~wxTaskBarIcon | ( |  | ) | `[virtual]`

Destroys the wxTaskBarIcon object, removing the icon if not already removed.

## Member Function Documentation

virtual wxMenu* wxTaskBarIcon::CreatePopupMenu | ( |  | ) | `[protected, virtual]`

This method is called by the library when the user requests popup menu (on Windows and Unix platforms, this is when the user right-clicks the icon).

Override this function in order to provide popup menu associated with the icon. If CreatePopupMenu() returns NULL (this happens by default), no menu is shown, otherwise the menu is displayed and then deleted by the library as soon as the user dismisses it.

The events can be handled by a class derived from wxTaskBarIcon.

void wxTaskBarIcon::Destroy | ( |  | ) |

This method is similar to wxWindow::Destroy and can be used to schedule the task bar icon object for the delayed destruction: it will be deleted during the next event loop iteration, which allows the task bar icon to process any pending events for it before being destroyed.

static bool wxTaskBarIcon::IsAvailable | ( |  | ) | `[static]`

Returns true if system tray is available in the desktop environment the app runs under.

On Windows and Mac OS X, the tray is always available and this function simply returns true.

On Unix, X11 environment may or may not provide the tray, depending on user's desktop environment. Most modern desktops support the tray via the System Tray Protocol by freedesktop.org (http://freedesktop.org/wiki/Specifications/systemtray-spec).

Note:
  Tray availability may change during application's lifetime under X11 and so applications shouldn't cache the result.

  wxTaskBarIcon supports older GNOME 1.2 and KDE 1/2 methods of adding icons to tray, but they are unreliable and this method doesn't detect them.

Since:
  2.9.0

bool wxTaskBarIcon::IsIconInstalled | ( |  | ) | const

Returns true if SetIcon() was called with no subsequent RemoveIcon().

bool wxTaskBarIcon::IsOk | ( |  | ) | const

Returns true if the object initialized successfully.

virtual bool wxTaskBarIcon::PopupMenu | ( | wxMenu * | menu | ) | `[virtual]`

Pops up a menu at the current mouse position.

The events can be handled by a class derived from wxTaskBarIcon.

Note:
  It is recommended to override CreatePopupMenu() callback instead of calling this method from event handler, because some ports (e.g. wxCocoa) may not implement PopupMenu() and mouse click events at all.

virtual bool wxTaskBarIcon::RemoveIcon | ( |  | ) | `[virtual]`

Removes the icon previously set with SetIcon().

virtual bool wxTaskBarIcon::SetIcon | ( | const wxIcon & | icon,
|  | const wxString & | tooltip = `wxEmptyString` |
| ) |  |  | `[virtual]`

Sets the icon, and optional tooltip text.

|  | [ top ]